Index: code/branches/lod/bin/def_keybindings.ini
===================================================================
--- code/branches/lod/bin/def_keybindings.ini	(revision 2057)
+++ code/branches/lod/bin/def_keybindings.ini	(revision 2058)
@@ -254,7 +254,7 @@
 
 [MouseAxes]
-MouseXNeg=
-MouseXPos=
-MouseYNeg=
-MouseYPos=
+MouseXNeg="scale 1 moveYaw"
+MouseXPos="scale -1 moveYaw"
+MouseYNeg="scale 1 movePitch"
+MouseYPos="scale -1 movePitch"
 
Index: code/branches/lod/src/core/XMLPort.h
===================================================================
--- code/branches/lod/src/core/XMLPort.h	(revision 2057)
+++ code/branches/lod/src/core/XMLPort.h	(revision 2058)
@@ -468,5 +468,4 @@
                             for (ticpp::Iterator<ticpp::Element> child = xmlsubelement->FirstChildElement(false); child != child.end(); child++)
                             {
-                                COUT(2) << child->Value() << std::endl;
                                 Identifier* identifier = ClassByName(child->Value());
                                 if (identifier)
Index: code/branches/lod/src/core/input/InputManager.cc
===================================================================
--- code/branches/lod/src/core/input/InputManager.cc	(revision 2057)
+++ code/branches/lod/src/core/input/InputManager.cc	(revision 2058)
@@ -47,4 +47,5 @@
 #include "core/CommandExecutor.h"
 #include "core/ConsoleCommand.h"
+#include "core/CommandLine.h"
 #include "util/Debug.h"
 
@@ -62,4 +63,5 @@
     SetConsoleCommand(InputManager, calibrate, true);
     SetConsoleCommand(InputManager, reload, false);
+    SetCommandLineSwitch(keyboard_no_grab);
 
     std::string InputManager::bindingCommmandString_s = "";
@@ -153,4 +155,12 @@
 #if defined OIS_LINUX_PLATFORM
             paramList.insert(std::make_pair(std::string("XAutoRepeatOn"), std::string("true")));
+            paramList.insert(std::make_pair(std::string("x11_mouse_grab"), "true"));
+            paramList.insert(std::make_pair(std::string("x11_mouse_hide"), "true"));
+            bool kbNoGrab;
+            CommandLine::getValue("keyboard_no_grab", &kbNoGrab);
+            if (kbNoGrab)
+                paramList.insert(std::make_pair(std::string("x11_keyboard_grab"), std::string("false")));
+            else
+                paramList.insert(std::make_pair(std::string("x11_keyboard_grab"), std::string("true")));
 #endif
 
Index: code/branches/lod/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- code/branches/lod/src/orxonox/OrxonoxStableHeaders.h	(revision 2057)
+++ code/branches/lod/src/orxonox/OrxonoxStableHeaders.h	(revision 2058)
@@ -46,5 +46,4 @@
 #endif
 #include <Ogre.h>
-#include <OgreProgressiveMesh.h>
 #include <CEGUI.h>
 #include <boost/thread/recursive_mutex.hpp>
Index: code/branches/lod/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/branches/lod/src/orxonox/gamestates/GSLevel.cc	(revision 2057)
+++ code/branches/lod/src/orxonox/gamestates/GSLevel.cc	(revision 2058)
@@ -38,4 +38,5 @@
 #include "core/CommandExecutor.h"
 #include "core/ConsoleCommand.h"
+#include "core/CommandLine.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
@@ -49,4 +50,6 @@
 namespace orxonox
 {
+    SetCommandLineArgument(level, "sample.oxw").setShortcut("l");
+
     GSLevel::GSLevel(const std::string& name)
         : GameState<GSGraphics>(name)
@@ -157,5 +160,7 @@
         // call the loader
         COUT(0) << "Loading level..." << std::endl;
-        startLevel_ = new Level(Settings::getDataPath() + "levels/sample.oxw");
+        std::string levelName;
+        CommandLine::getValue("level", &levelName);
+        startLevel_ = new Level(Settings::getDataPath() + std::string("levels/") + levelName);
         Loader::open(startLevel_);
     }
Index: code/branches/lod/src/util/OrxonoxPlatform.h
===================================================================
--- code/branches/lod/src/util/OrxonoxPlatform.h	(revision 2057)
+++ code/branches/lod/src/util/OrxonoxPlatform.h	(revision 2058)
@@ -137,4 +137,15 @@
 }
 
+//-----------------------------------------------------------------------
+// Version Information
+//-----------------------------------------------------------------------
+
+#define ORXONOX_VERSION_MAJOR 0
+#define ORXONOX_VERSION_MINOR 1
+#define ORXONOX_VERSION_PATCH 2
+#define ORXONOX_VERSION_SUFFIX ""
+#define ORXONOX_VERSION_NAME "Bellatrix"
+
+#define ORXONOX_VERSION ((ORXONOX_VERSION_MAJOR << 16) | (ORXONOX_VERSION_MINOR << 8) | ORXONOX_VERSION_PATCH)
 
 